class PotentialmemberImport
  # switch to ActiveModel::Model in Rails 4
  extend ActiveModel::Model
  #extend ActiveModel::Naming
  include ActiveModel::Conversion
  include ActiveModel::Validations

  attr_accessor :file

  def initialize(attributes = {})
    attributes.each { |name, value| send("#{name}=", value) }
  end

  def persisted?
    false
  end

  def save
    if imported_potentialmembers.map(&:valid?).all?
      imported_potentialmembers.each(&:save!)
      true
    else
      imported_potentialmembers.each_with_index do |potentialmember, index|
        potentialmember.errors.full_messages.each do |message|
          errors.add :base, "Row #{index+2}: #{message}"
        end
      end
      false
    end
  end

  def imported_potentialmembers
    @imported_potentialmembers ||= load_imported_potentialmembers
  end

  def load_imported_potentialmembers
    spreadsheet = open_spreadsheet
    header = spreadsheet.row(1)
    (2..spreadsheet.last_row).map do |i|
      row = Hash[[header, spreadsheet.row(i)].transpose]
      potentialmember = Potentialmember.find_by_id(row["id"]) || Potentialmember.new
      potentialmember.attributes = row.to_hash.slice(*Potentialmember.accessible_attributes)
      potentialmember
    end
  end

  def open_spreadsheet
    case File.extname(file.original_filename)
    when ".csv" then Csv.new(file.path, nil, :ignore)
    when ".xls" then Excel.new(file.path, nil, :ignore)
    when ".xlsx" then Excelx.new(file.path, nil, :ignore)
    else raise "Unknown file type: #{file.original_filename}"
    end
  end

end
